function d_xf = J_rk4(f, J, t0, x0, h)

d_x0 = eye(length(x0));

k1 = h * f(t0, x0);
d_k1 =  h * J(t0, x0);

x1 = x0 + 0.5*k1;
d_x1 = d_x0 + 0.5*d_k1;

k2 = h * f(t0 + 0.5*h, x1);
d_k2 = h * J(t0 + 0.5*h, x1)*d_x1;

x2 = x0 + 0.5*k2;
d_x2 = d_x0 + 0.5*d_k2;

k3 = h * f(t0 + 0.5*h, x2);
d_k3 = h * J(t0 + 0.5*h, x2)*d_x2;

x3 = x0 + k3;
d_x3 = d_x0 + d_k3;

k4 = h * f(t0 + h, x3);
d_k4 = h * J(t0 + h, x3)*d_x3;

xf = x0 + (1/6)*(k1 + 2*k2 + 2*k3 + k4);
d_xf = d_x0 + (1/6)*(d_k1 + 2*d_k2 + 2*d_k3 + d_k4);
