function d_xdot = dfdx_cont(t, x)

u = control_input(t);

d_x = eye(5);

beta = x(3);
d_beta = d_x(3,:);

r1 = x(4);
d_r1 = d_x(4,:);

r2 = x(5);
d_r2 = d_x(5,:);

v1 = u(1)*r1;
d_v1 = u(1)*d_r1;

v2 = u(2)*r2;
d_v2 = u(2)*d_r2;

v = 0.5*(v1 + v2);
d_v = 0.5*(d_v1 + d_v2);

D = 1;

xdot = [
    v*cos(beta)
    v*sin(beta)
    (v2 - v1)/D
    0
    0
    ];
d_xdot = [
    d_v.*cos(beta) - v.*sin(beta)*d_beta
    d_v.*sin(beta) + v.*cos(beta)*d_beta
    (d_v2 - d_v1)./D
    zeros(1,5)
    zeros(1,5)
    ];
